## GtkPaned

GtkPaned — A widget with two adjustable panes

## Functions

GtkWidget * | gtk_paned_new ()
void | gtk_paned_add1 ()
void | gtk_paned_add2 ()
void | gtk_paned_pack1 ()
void | gtk_paned_pack2 ()
GtkWidget * | gtk_paned_get_child1 ()
GtkWidget * | gtk_paned_get_child2 ()
void | gtk_paned_set_position ()
gint | gtk_paned_get_position ()
GdkWindow * | gtk_paned_get_handle_window ()
void | gtk_paned_set_wide_handle ()
gboolean | gtk_paned_get_wide_handle ()

## Properties

int | max-position | Read
int | min-position | Read
int | position | Read / Write
gboolean | position-set | Read / Write
gboolean | wide-handle | Read / Write

## Child Properties

gboolean | resize | Read / Write
gboolean | shrink | Read / Write

## Style Properties

int | handle-size | Read

## Signals

gboolean | accept-position | Action
gboolean | cancel-position | Action
gboolean | cycle-child-focus | Action
gboolean | cycle-handle-focus | Action
gboolean | move-handle | Action
gboolean | toggle-handle-focus | Action

## Types and Values

struct | GtkPaned

## Object Hierarchy

        GObject
        ╰── GInitiallyUnowned
            ╰── GtkWidget
                ╰── GtkContainer
                    ╰── GtkPaned
                        ├── GtkHPaned
                        ╰── GtkVPaned

## Implemented Interfaces

GtkPaned implements AtkImplementorIface, GtkBuildable and GtkOrientable.

## Includes

    #include <gtk/gtk.h>

## Description

GtkPaned has two panes, arranged either horizontally or vertically. The division between the two panes is adjustable by the user by dragging a handle.

Child widgets are added to the panes of the widget with `gtk_paned_pack1()` and `gtk_paned_pack2()`. The division between the two children is set by default from the size requests of the children, but it can be adjusted by the user.

A paned widget draws a separator between the two child widgets and a small handle that the user can drag to adjust the division. It does not draw any relief around the children or around the separator. (The space in which the separator is called the gutter.) Often, it is useful to put each child inside a GtkFrame with the shadow type set to `GTK_SHADOW_IN` so that the gutter appears as a ridge. No separator is drawn if one of the children is missing.

Each child has two options that can be set, `resize` and `shrink` . If `resize` is true, then when the GtkPaned is resized, that child will expand or shrink along with the paned widget. If `shrink` is true, then that child can be made smaller than its requisition by the user. Setting `shrink` to `FALSE` allows the application to set a minimum size. If `resize` is false for both children, then this is treated as if `resize` is true for both children.

The application can set the position of the slider as if it were set by the user, by calling `gtk_paned_set_position()`.

### CSS nodes

    1
    2
    3
    4

    paned
    ├── <child>
    ├── separator[.wide]
    ╰── <child>

GtkPaned has a main CSS node with name paned, and a subnode for the separator with name separator. The subnode gets a .wide style class when the paned is supposed to be wide.

In horizontal orientation, the nodes of the children are always arranged from left to right. So :first-child will always select the leftmost child, regardless of text direction.

#### Creating a paned widget with minimum sizes.

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13

    GtkWidget *hpaned = gtk_paned_new (GTK_ORIENTATION_HORIZONTAL);
    GtkWidget *frame1 = gtk_frame_new (NULL);
    GtkWidget *frame2 = gtk_frame_new (NULL);
    gtk_frame_set_shadow_type (GTK_FRAME (frame1), GTK_SHADOW_IN);
    gtk_frame_set_shadow_type (GTK_FRAME (frame2), GTK_SHADOW_IN);

    gtk_widget_set_size_request (hpaned, 200, -1);

    gtk_paned_pack1 (GTK_PANED (hpaned), frame1, TRUE, FALSE);
    gtk_widget_set_size_request (frame1, 50, -1);

    gtk_paned_pack2 (GTK_PANED (hpaned), frame2, FALSE, FALSE);
    gtk_widget_set_size_request (frame2, 50, -1);

## Functions

### gtk_paned_new ()

    GtkWidget *
    gtk_paned_new (GtkOrientation orientation);

Creates a new GtkPaned widget.

#### Parameters

orientation | the paned’s orientation. |

#### Returns

a new GtkPaned.

Since: 3.0

### gtk_paned_add1 ()

    void
    gtk_paned_add1 (GtkPaned *paned,
                    GtkWidget *child);

Adds a child to the top or left pane with default parameters. This is equivalent to `gtk_paned_pack1 (paned, child, FALSE, TRUE)`.

#### Parameters

paned | a paned widget |
child | the child to add |

### gtk_paned_add2 ()

    void
    gtk_paned_add2 (GtkPaned *paned,
                    GtkWidget *child);

Adds a child to the bottom or right pane with default parameters. This is equivalent to `gtk_paned_pack2 (paned, child, TRUE, TRUE)`.

#### Parameters

paned | a paned widget |
child | the child to add |

### gtk_paned_pack1 ()

    void
    gtk_paned_pack1 (GtkPaned *paned,
                     GtkWidget *child,
                     gboolean resize,
                     gboolean shrink);

Adds a child to the top or left pane.

#### Parameters

paned | a paned widget |
child | the child to add |
resize | should this child expand when the paned widget is resized. |
shrink | can this child be made smaller than its requisition. |

### gtk_paned_pack2 ()

    void
    gtk_paned_pack2 (GtkPaned *paned,
                     GtkWidget *child,
                     gboolean resize,
                     gboolean shrink);

Adds a child to the bottom or right pane.

#### Parameters

paned | a paned widget |
child | the child to add |
resize | should this child expand when the paned widget is resized. |
shrink | can this child be made smaller than its requisition. |

### gtk_paned_get_child1 ()

    GtkWidget *
    gtk_paned_get_child1 (GtkPaned *paned);

Obtains the first child of the paned widget.

#### Parameters

paned | a GtkPaned widget |

#### Returns

first child, or `NULL` if it is not set.

[nullable][transfer none]

Since: 2.4

### gtk_paned_get_child2 ()

    GtkWidget *
    gtk_paned_get_child2 (GtkPaned *paned);

Obtains the second child of the paned widget.

#### Parameters

paned | a GtkPaned widget |

#### Returns

second child, or `NULL` if it is not set.

[nullable][transfer none]

Since: 2.4

### gtk_paned_set_position ()

    void
    gtk_paned_set_position (GtkPaned *paned,
                            gint position);

Sets the position of the divider between the two panes.

#### Parameters

paned | a GtkPaned widget |
position | pixel position of divider, a negative value means that the position is unset. |

### gtk_paned_get_position ()

    gint
    gtk_paned_get_position (GtkPaned *paned);

Obtains the position of the divider between the two panes.

#### Parameters

paned | a GtkPaned widget |

#### Returns

position of the divider

### gtk_paned_get_handle_window ()

    GdkWindow *
    gtk_paned_get_handle_window (GtkPaned *paned);

Returns the GdkWindow of the handle. This function is useful when handling button or motion events because it enables the callback to distinguish between the window of the paned, a child and the handle.

#### Parameters

paned | a GtkPaned |

#### Returns

the paned’s handle window.

[transfer none]

Since: 2.20

### gtk_paned_set_wide_handle ()

    void
    gtk_paned_set_wide_handle (GtkPaned *paned,
                               gboolean wide);

Sets the “wide-handle” property.

#### Parameters

paned | a GtkPaned |
wide | the new value for the “wide-handle” property |

Since: 3.16

### gtk_paned_get_wide_handle ()

    gboolean
    gtk_paned_get_wide_handle (GtkPaned *paned);

Gets the “wide-handle” property.

#### Parameters

paned | a GtkPaned |

#### Returns

`TRUE` if the paned should have a wide handle

Since: 3.16

## Types and Values

### struct GtkPaned

    struct GtkPaned;

## Property Details

### The `“max-position”` property

      “max-position”             int

The largest possible value for the position property. This property is derived from the size and shrinkability of the widget's children.

Owner: GtkPaned

Flags: Read

Allowed values: >= 0

Default value: 2147483647

Since: 2.4

### The `“min-position”` property

      “min-position”             int

The smallest possible value for the position property. This property is derived from the size and shrinkability of the widget's children.

Owner: GtkPaned

Flags: Read

Allowed values: >= 0

Default value: 0

Since: 2.4

### The `“position”` property

      “position”                 int

Position of paned separator in pixels (0 means all the way to the left/top).

Owner: GtkPaned

Flags: Read / Write

Allowed values: >= 0

Default value: 0

### The `“position-set”` property

      “position-set”             gboolean

TRUE if the Position property should be used.

Owner: GtkPaned

Flags: Read / Write

Default value: FALSE

### The `“wide-handle”` property

      “wide-handle”              gboolean

Setting this property to `TRUE` indicates that the paned needs to provide stronger visual separation (e.g. because it separates between two notebooks, whose tab rows would otherwise merge visually).

Owner: GtkPaned

Flags: Read / Write

Default value: FALSE

Since: 3.16

## Child Property Details

### The `“resize”` child property

      “resize”                   gboolean

The "resize" child property determines whether the child expands and shrinks along with the paned widget.

Owner: GtkPaned

Flags: Read / Write

Default value: TRUE

Since: 2.4

### The `“shrink”` child property

      “shrink”                   gboolean

The "shrink" child property determines whether the child can be made smaller than its requisition.

Owner: GtkPaned

Flags: Read / Write

Default value: TRUE

Since: 2.4

## Style Property Details

### The `“handle-size”` style property

      “handle-size”              int

Width of handle.

Owner: GtkPaned

Flags: Read

Allowed values: >= 0

Default value: 5

## Signal Details

### The `“accept-position”` signal

    gboolean
    user_function (GtkPaned *widget,
                   gpointer  user_data)

The ::accept-position signal is a keybinding signal which gets emitted to accept the current position of the handle when moving it using key bindings.

The default binding for this signal is Return or Space.

#### Parameters

widget | the object that received the signal |
user_data | user data set when the signal handler was connected. |

Flags: Action

Since: 2.0

### The `“cancel-position”` signal

    gboolean
    user_function (GtkPaned *widget,
                   gpointer  user_data)

The ::cancel-position signal is a keybinding signal which gets emitted to cancel moving the position of the handle using key bindings. The position of the handle will be reset to the value prior to moving it.

The default binding for this signal is Escape.

#### Parameters

widget | the object that received the signal |
user_data | user data set when the signal handler was connected. |

Flags: Action

Since: 2.0

### The `“cycle-child-focus”` signal

    gboolean
    user_function (GtkPaned *widget,
                   gboolean  reversed,
                   gpointer  user_data)

The ::cycle-child-focus signal is a keybinding signal which gets emitted to cycle the focus between the children of the paned.

The default binding is f6.

#### Parameters

widget | the object that received the signal |
reversed | whether cycling backward or forward |
user_data | user data set when the signal handler was connected. |

Flags: Action

Since: 2.0

### The `“cycle-handle-focus”` signal

    gboolean
    user_function (GtkPaned *widget,
                   gboolean  reversed,
                   gpointer  user_data)

The ::cycle-handle-focus signal is a keybinding signal which gets emitted to cycle whether the paned should grab focus to allow the user to change position of the handle by using key bindings.

The default binding for this signal is f8.

#### Parameters

widget | the object that received the signal |
reversed | whether cycling backward or forward |
user_data | user data set when the signal handler was connected. |

Flags: Action

Since: 2.0

### The `“move-handle”` signal

    gboolean
    user_function (GtkPaned     *widget,
                   GtkScrollType scroll_type,
                   gpointer      user_data)

The ::move-handle signal is a keybinding signal which gets emitted to move the handle when the user is using key bindings to move it.

#### Parameters

widget | the object that received the signal |
scroll_type | a GtkScrollType |
user_data | user data set when the signal handler was connected. |

Flags: Action

Since: 2.0

### The `“toggle-handle-focus”` signal

    gboolean
    user_function (GtkPaned *widget,
                   gpointer  user_data)

The ::toggle-handle-focus is a keybinding signal which gets emitted to accept the current position of the handle and then move focus to the next widget in the focus chain.

The default binding is Tab.

#### Parameters

widget | the object that received the signal |
user_data | user data set when the signal handler was connected. |

Flags: Action

Since: 2.0